diff -r 3ac6556ec8e0 trytond/modules/stock_supply_production/production.py
--- a/trytond/modules/stock_supply_production/production.py	Mon Sep 24 18:27:07 2012 +0200
+++ b/trytond/modules/stock_supply_production/production.py	Mon Sep 24 20:36:43 2012 +0200
@@ -3,28 +3,31 @@
 import datetime
 from decimal import Decimal
 
-from trytond.model import Model, ModelView, fields
-from trytond.pool import Pool
+from trytond.model import ModelView, fields
+from trytond.pool import Pool, PoolMeta
 from trytond.transaction import Transaction
 from trytond.wizard import Wizard, StateView, StateAction, Button
 
+__all__ = ['Configuration', 'Production',
+    'CreateProductionRequestStart', 'CreateProductionRequest']
+__metaclass__ = PoolMeta
 
-class Configuration(Model):
-    _name = 'production.configuration'
 
+class Configuration:
+    __name__ = 'production.configuration'
     supply_period = fields.Property(fields.Numeric('Supply Period',
             digits=(16, 0), help='In number of days', required=True))
 
-    def default_supply_period(self):
+    @staticmethod
+    def default_supply_period():
         return Decimal(0)
 
-Configuration()
 
+class Production:
+    __name__ = 'production'
 
-class Production(Model):
-    _name = 'production'
-
-    def generate_requests(self, clean=True):
+    @classmethod
+    def generate_requests(cls, clean=True):
         """
         For each product compute the production request that must be created
         today to meet product outputs.
@@ -32,97 +35,98 @@
         If clean is set, it will remove all previous requests.
         """
         pool = Pool()
-        order_point_obj = pool.get('stock.order_point')
-        product_obj = pool.get('product.product')
-        location_obj = pool.get('stock.location')
-        date_obj = pool.get('ir.date')
-        user_obj = pool.get('res.user')
-        company = user_obj.browse(Transaction().user).company
+        OrderPoint = pool.get('stock.order_point')
+        Product = pool.get('product.product')
+        Location = pool.get('stock.location')
+        Date = pool.get('ir.date')
+        User = pool.get('res.user')
+        company = User(Transaction().user).company
 
         if clean:
-            req_ids = self.search([
+            reqs = cls.search([
                     ('state', '=', 'request'),
                     ])
-            self.delete(req_ids)
+            cls.delete(reqs)
 
         # fetch warehouse
-        warehouse_ids = location_obj.search([
+        warehouses = Location.search([
                 ('type', '=', 'warehouse'),
                 ])
-        warehouses = location_obj.browse(warehouse_ids)
+        warehouse_ids = [w.id for w in warehouses]
         # fetch order points
-        order_point_ids = order_point_obj.search([
+        order_points = OrderPoint.search([
                 ('type', '=', 'production'),
                 ])
         # index them by product
         product2ops = {}
-        for order_point in order_point_obj.browse(order_point_ids):
+        for order_point in order_points:
             product2ops[
                 (order_point.warehouse_location.id, order_point.product.id)
                 ] = order_point
 
         # fetch goods
-        product_ids = product_obj.search([
+        products = Product.search([
                 ('type', '=', 'goods'),
                 ('consumable', '=', False),
                 ('purchasable', '=', False),
                 ])
-        products = product_obj.browse(product_ids)
         # order product by supply period
-        products_period = sorted([(product_obj.get_supply_period(p), p)
-            for p in products])
+        products_period = sorted([(p.get_supply_period(), p)
+                for p in products])
 
         # compute requests
         cursor = Transaction().cursor
-        today = date_obj.today()
+        today = Date.today()
         requests = []
         for i in range(0, len(products), cursor.IN_MAX):
             product_ids = [p.id for p in products[i:i + cursor.IN_MAX]]
             with Transaction().set_context(forecast=True,
                     stock_date_end=today):
-                pbl = product_obj.products_by_location(warehouse_ids,
+                pbl = Product.products_by_location(warehouse_ids,
                     product_ids, with_childs=True, skip_zero=False)
             for warehouse in warehouses:
                 quantities = dict((x, pbl.pop((warehouse.id, x)))
                     for x in product_ids)
-                shortages = self.get_shortage(warehouse.id, product_ids, today,
+                shortages = cls.get_shortage(warehouse.id, product_ids, today,
                     quantities, products_period, product2ops)
 
                 for product in products[i:i + cursor.IN_MAX]:
                     for date, quantity in shortages[product.id]:
-                        req_values = self.compute_request(product, warehouse,
+                        req = cls.compute_request(product, warehouse,
                             quantity, date, company)
-                        req_id = self.create(req_values)
-                        self.set_moves(self.browse(req_id))
-                        requests.append(req_id)
+                        req.save()
+                        req.set_moves()
+                        requests.append(req)
         if requests:
-            self.generate_requests(clean=False)
+            cls.generate_requests(clean=False)
         return requests
 
-    def compute_request(self, product, warehouse, quantity, date, company):
+    @classmethod
+    def compute_request(cls, product, warehouse, quantity, date, company):
         """
         Return the value of the production request.
         """
         pool = Pool()
-        date_obj = pool.get('ir.date')
-        today = date_obj.today()
+        Date = pool.get('ir.date')
+        today = Date.today()
         if date <= today:
             date = today
         else:
             date -= datetime.timedelta(1)
-        return {
-            'planned_date': date,
-            'company': company.id,
-            'warehouse': warehouse.id,
-            'location': warehouse.production_location.id,
-            'product': product.id,
-            'bom': product.boms[0].bom.id if product.boms else None,
-            'uom': product.default_uom.id,
-            'quantity': quantity,
-            'state': 'request',
-            }
+        return cls(
+            planned_date=date,
+            company=company,
+            warehouse=warehouse,
+            location=warehouse.production_location,
+            product=product,
+            bom=product.boms[0].bom if product.boms else None,
+            uom=product.default_uom,
+            quantity=quantity,
+            state='request',
+            )
 
-    def get_shortage(self, location_id, product_ids, date, quantities,
+    @classmethod
+    def get_shortage(cls, location_id, product_ids, date, quantities,
             products_period, order_points):
         """
         Return for each product a list of dates where the stock quantity is
@@ -137,7 +141,7 @@
         order_points is a dictionary that links products to order points.
         """
         pool = Pool()
-        product_obj = pool.get('product.product')
+        Product = pool.get('product.product')
 
         shortages = {}
 
@@ -170,7 +174,7 @@
             # Update current quantities
             with Transaction().set_context(stock_date_start=current_date,
                     stock_date_end=current_date):
-                pbl = product_obj.products_by_location([location_id],
+                pbl = Product.products_by_location([location_id],
                     product_ids, with_childs=True, skip_zero=False)
             for key, qty in pbl.iteritems():
                 _, product_id = key
@@ -185,21 +189,15 @@
 
         return shortages
 
-Production()
-
 
 class CreateProductionRequestStart(ModelView):
     'Create Production Request'
-    _name = 'production.create_request.start'
-    _description = __doc__
-
-CreateProductionRequestStart()
+    __name__ = 'production.create_request.start'
 
 
 class CreateProductionRequest(Wizard):
     'Create Production Request'
-    _name = 'production.create_request'
-
+    __name__ = 'production.create_request'
     start = StateView('production.create_request.start',
         'stock_supply_production.production_create_request_start_view_form', [
             Button('Cancel', 'end', 'tryton-cancel'),
@@ -207,13 +205,11 @@
             ])
     create_ = StateAction('production.act_production_request')
 
-    def do_create_(self, session, action):
+    def do_create_(self, action):
         pool = Pool()
-        production_obj = pool.get('production')
-        production_obj.generate_requests()
+        Production = pool.get('production')
+        Production.generate_requests()
         return action, {}
 
-    def transition_create_(self, session):
+    def transition_create_(self):
         return 'end'
-
-CreateProductionRequest()
diff -r 3ac6556ec8e0 trytond/modules/stock_supply_production/stock.py
--- a/trytond/modules/stock_supply_production/stock.py	Mon Sep 24 18:27:07 2012 +0200
+++ b/trytond/modules/stock_supply_production/stock.py	Mon Sep 24 20:36:43 2012 +0200
@@ -1,46 +1,39 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
-import copy
+from trytond.pyson import Eval
+from trytond.pool import PoolMeta
 
-from trytond.model import Model
-from trytond.pyson import Eval
+__all__ = ['OrderPoint']
+__metaclass__ = PoolMeta
 
 
-class OrderPoint(Model):
-    _name = 'stock.order_point'
+class OrderPoint:
+    __name__ = 'stock.order_point'
 
-    def __init__(self):
-        super(OrderPoint, self).__init__()
+    @classmethod
+    def __setup__(cls):
+        super(OrderPoint, cls).__setup__()
 
-        self.warehouse_location = copy.copy(self.warehouse_location)
-        states = copy.copy(self.warehouse_location.states)
-        states['invisible'] = (states['invisible']
-            & (Eval('type') != 'production'))
-        states['required'] = (states['required']
-            | (Eval('type') == 'production'))
-        self.warehouse_location.states = states
+        cls.warehouse_location.states['invisible'] &= (
+            Eval('type') != 'production')
+        cls.warehouse_location.states['required'] |= (
+            Eval('type') == 'production')
 
         option = ('production', 'Production')
-        if option not in self.type.selection:
-            self.type = copy.copy(self.type)
-            self.type.selection = copy.copy(self.type.selection)
-            self.type.selection.append(option)
+        if option not in cls.type.selection:
+            cls.type.selection.append(option)
 
-        self._reset_columns()
-
-    def _type2field(self, type=None):
+    @classmethod
+    def _type2field(cls, type=None):
         if type == 'production':
             return 'warehouse_location'
-        result = super(OrderPoint, self)._type2field(type=type)
+        result = super(OrderPoint, cls)._type2field(type=type)
         if type == None:
             result['production'] = 'warehouse_location'
         return result
 
-    def get_location(self, ids, name):
-        locations = super(OrderPoint, self).get_location(ids, name)
-        for op in self.browse(ids):
-            if op.type == 'production':
-                locations[op.id] = op.warehouse_location.id
-        return locations
-
-OrderPoint()
+    def get_location(self, name):
+        location = super(OrderPoint, self).get_location(name)
+        if self.type == 'production':
+            return self.warehouse_location.id
+        return location
diff -r 3d07cd37899c trytond/modules/timesheet/__init__.py
--- a/trytond/modules/timesheet/__init__.py	Fri Sep 21 15:41:53 2012 +0200
+++ b/trytond/modules/timesheet/__init__.py	Mon Sep 24 20:36:44 2012 +0200
@@ -1,5 +1,26 @@
 #This file is part of Tryton.  The COPYRIGHT file at the top level of
 #this repository contains the full copyright notices and license terms.
 
+from trytond.pool import Pool
 from .work import *
 from .line import *
+
+
+def register():
+    Pool.register(
+        Work,
+        OpenWorkStart,
+        Line,
+        EnterLinesStart,
+        HoursEmployee,
+        OpenHoursEmployeeStart,
+        HoursEmployeeWeekly,
+        HoursEmployeeMonthly,
+        module='timesheet', type_='model')
+    Pool.register(
+        OpenWork,
+        OpenWork2,
+        OpenWorkGraph,
+        EnterLines,
+        OpenHoursEmployee,
+        module='timesheet', type_='wizard')
diff -r 3d07cd37899c trytond/modules/timesheet/line.py
--- a/trytond/modules/timesheet/line.py	Fri Sep 21 15:41:53 2012 +0200
+++ b/trytond/modules/timesheet/line.py	Mon Sep 24 20:36:44 2012 +0200
@@ -7,12 +7,15 @@
 from trytond.transaction import Transaction
 from trytond.pool import Pool
 
+__all__ = ['Line', 'EnterLinesStart', 'EnterLines',
+    'HoursEmployee',
+    'OpenHoursEmployeeStart', 'OpenHoursEmployee',
+    'HoursEmployeeWeekly', 'HoursEmployeeMonthly']
+
 
 class Line(ModelSQL, ModelView):
     'Timesheet Line'
-    _name = 'timesheet.line'
-    _description = __doc__
-
+    __name__ = 'timesheet.line'
     employee = fields.Many2One('company.employee', 'Employee', required=True,
         select=True, domain=[
             ('company', '=', Get(Eval('context', {}), 'company')),
@@ -25,63 +28,62 @@
             ])
     description = fields.Char('Description')
 
-    def __init__(self):
-        super(Line, self).__init__()
-        self._sql_constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(Line, cls).__setup__()
+        cls._sql_constraints += [
             ('check_move_hours_pos',
              'CHECK(hours >= 0.0)', 'Hours field must be positive'),
             ]
 
-    def default_employee(self):
-        user_obj = Pool().get('res.user')
+    @staticmethod
+    def default_employee():
+        User = Pool().get('res.user')
         employee_id = None
         if Transaction().context.get('employee'):
             employee_id = Transaction().context['employee']
         else:
-            user = user_obj.browse(Transaction().user)
+            user = User(Transaction().user)
             if user.employee:
                 employee_id = user.employee.id
         if employee_id:
             return employee_id
 
-    def default_date(self):
-        date_obj = Pool().get('ir.date')
+    @staticmethod
+    def default_date():
+        Date_ = Pool().get('ir.date')
+        return Transaction().context.get('date') or Date_.today()
 
-        return Transaction().context.get('date') or date_obj.today()
-
-    def view_header_get(self, value, view_type='form'):
+    @classmethod
+    def view_header_get(cls, value, view_type='form'):
         if not Transaction().context.get('employee'):
             return value
-        employee_obj = Pool().get('company.employee')
-        employee = employee_obj.browse(Transaction().context['employee'])
+        Employee = Pool().get('company.employee')
+        employee = Employee(Transaction().context['employee'])
         return value + " (" + employee.name + ")"
 
-Line()
-
 
 class EnterLinesStart(ModelView):
     'Enter Lines'
-    _name = 'timesheet.line.enter.start'
-    _description = __doc__
+    __name__ = 'timesheet.line.enter.start'
     employee = fields.Many2One('company.employee', 'Employee', required=True,
             domain=[('company', '=', Get(Eval('context', {}), 'company'))])
     date = fields.Date('Date', required=True)
 
-    def default_employee(self):
-        line_obj = Pool().get('timesheet.line')
-        return line_obj.default_employee()
+    @staticmethod
+    def default_employee():
+        Line = Pool().get('timesheet.line')
+        return Line.default_employee()
 
-    def default_date(self):
-        line_obj = Pool().get('timesheet.line')
-        return line_obj.default_date()
-
-EnterLinesStart()
+    @staticmethod
+    def default_date():
+        Line = Pool().get('timesheet.line')
+        return Line.default_date()
 
 
 class EnterLines(Wizard):
     'Enter Lines'
-    _name = 'timesheet.line.enter'
-
+    __name__ = 'timesheet.line.enter'
     start = StateView('timesheet.line.enter.start',
         'timesheet.line_enter_start_view_form', [
             Button('Cancel', 'end', 'tryton-cancel'),
@@ -89,35 +91,32 @@
             ])
     enter = StateAction('timesheet.act_line_form')
 
-    def do_enter(self, session, action):
-        date = session.start.date
+    def do_enter(self, action):
+        date = self.start.date
         date = Date(date.year, date.month, date.day)
         action['pyson_domain'] = PYSONEncoder().encode([
-                ('employee', '=', session.start.employee.id),
+                ('employee', '=', self.start.employee.id),
                 ('date', '=', date),
                 ])
         action['pyson_context'] = PYSONEncoder().encode({
-                'employee': session.start.employee.id,
+                'employee': self.start.employee.id,
                 'date': date,
                 })
-        action['name'] += " - " + session.start.employee.rec_name
+        action['name'] += " - " + self.start.employee.rec_name
         return action, {}
 
-    def transition_enter(self, session):
+    def transition_enter(self):
         return 'end'
 
-EnterLines()
-
 
 class HoursEmployee(ModelSQL, ModelView):
     'Hours per Employee'
-    _name = 'timesheet.hours_employee'
-    _description = __doc__
-
+    __name__ = 'timesheet.hours_employee'
     employee = fields.Many2One('company.employee', 'Employee', select=True)
     hours = fields.Float('Hours', digits=(16, 2))
 
-    def table_query(self):
+    @staticmethod
+    def table_query():
         clause = ' '
         args = [True]
         if Transaction().context.get('start_date'):
@@ -138,23 +137,17 @@
                 + clause + \
                 'GROUP BY employee', args)
 
-HoursEmployee()
-
 
 class OpenHoursEmployeeStart(ModelView):
     'Open Hours per Employee'
-    _name = 'timesheet.hours_employee.open.start'
-    _description = __doc__
+    __name__ = 'timesheet.hours_employee.open.start'
     start_date = fields.Date('Start Date')
     end_date = fields.Date('End Date')
 
-OpenHoursEmployeeStart()
-
 
 class OpenHoursEmployee(Wizard):
     'Open Hours per Employee'
-    _name = 'timesheet.hours_employee.open'
-
+    __name__ = 'timesheet.hours_employee.open'
     start = StateView('timesheet.hours_employee.open.start',
         'timesheet.hours_employee_open_start_view_form', [
             Button('Cancel', 'end', 'tryton-cancel'),
@@ -162,37 +155,35 @@
             ])
     open_ = StateAction('timesheet.act_hours_employee_form')
 
-    def do_open_(self, session, action):
+    def do_open_(self, action):
         action['pyson_context'] = PYSONEncoder().encode({
-                'start_date': session.start.start_date,
-                'end_date': session.start.end_date,
+                'start_date': self.start.start_date,
+                'end_date': self.start.end_date,
                 })
         return action, {}
 
-    def transition_open_(self, session):
+    def transition_open_(self):
         return 'end'
 
-OpenHoursEmployee()
-
 
 class HoursEmployeeWeekly(ModelSQL, ModelView):
     'Hours per Employee per Week'
-    _name = 'timesheet.hours_employee_weekly'
-    _description = __doc__
-
+    __name__ = 'timesheet.hours_employee_weekly'
     year = fields.Char('Year', select=True)
     week = fields.Integer('Week', select=True)
     employee = fields.Many2One('company.employee', 'Employee', select=True)
     hours = fields.Float('Hours', digits=(16, 2), select=True)
 
-    def __init__(self):
-        super(HoursEmployeeWeekly, self).__init__()
-        self._order.insert(0, ('year', 'DESC'))
-        self._order.insert(1, ('week', 'DESC'))
-        self._order.insert(2, ('employee', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(HoursEmployeeWeekly, cls).__setup__()
+        cls._order.insert(0, ('year', 'DESC'))
+        cls._order.insert(1, ('week', 'DESC'))
+        cls._order.insert(2, ('employee', 'ASC'))
 
-    def table_query(self):
-        type_name = FIELDS[self.year._type].sql_type(self.year)[0]
+    @classmethod
+    def table_query(cls):
+        type_name = FIELDS[cls.year._type].sql_type(cls.year)[0]
         return ('SELECT id, create_uid, create_date, write_uid, write_date, ' \
                     'CAST(year AS ' + type_name + ') AS year, week, ' \
                     'employee, hours ' \
@@ -208,29 +199,27 @@
                         'EXTRACT(WEEK FROM date) AS week, employee, ' \
                         'SUM(COALESCE(hours, 0)) AS hours ' \
                     'FROM timesheet_line ' \
-                    'GROUP BY year, week, employee) AS ' + self._table, [])
-
-HoursEmployeeWeekly()
+                    'GROUP BY year, week, employee) AS ' + cls._table, [])
 
 
 class HoursEmployeeMonthly(ModelSQL, ModelView):
     'Hours per Employee per Month'
-    _name = 'timesheet.hours_employee_monthly'
-    _description = __doc__
-
+    __name__ = 'timesheet.hours_employee_monthly'
     year = fields.Char('Year', select=True)
     month = fields.Integer('Month', select=True)
     employee = fields.Many2One('company.employee', 'Employee', select=True)
     hours = fields.Float('Hours', digits=(16, 2), select=True)
 
-    def __init__(self):
-        super(HoursEmployeeMonthly, self).__init__()
-        self._order.insert(0, ('year', 'DESC'))
-        self._order.insert(1, ('month', 'DESC'))
-        self._order.insert(2, ('employee', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(HoursEmployeeMonthly, cls).__setup__()
+        cls._order.insert(0, ('year', 'DESC'))
+        cls._order.insert(1, ('month', 'DESC'))
+        cls._order.insert(2, ('employee', 'ASC'))
 
-    def table_query(self):
-        type_name = FIELDS[self.year._type].sql_type(self.year)[0]
+    @classmethod
+    def table_query(cls):
+        type_name = FIELDS[cls.year._type].sql_type(cls.year)[0]
         return ('SELECT id, create_uid, create_date, write_uid, write_date, ' \
                     'CAST(year AS ' + type_name + ') AS year, month, ' \
                     'employee, hours ' \
@@ -246,6 +235,4 @@
                         'EXTRACT(MONTH FROM date) AS month, employee, ' \
                         'SUM(COALESCE(hours, 0)) AS hours ' \
                     'FROM timesheet_line ' \
-                    'GROUP BY year, month, employee) AS ' + self._table, [])
-
-HoursEmployeeMonthly()
+                    'GROUP BY year, month, employee) AS ' + cls._table, [])
diff -r 3d07cd37899c trytond/modules/timesheet/work.py
--- a/trytond/modules/timesheet/work.py	Fri Sep 21 15:41:53 2012 +0200
+++ b/trytond/modules/timesheet/work.py	Mon Sep 24 20:36:44 2012 +0200
@@ -6,12 +6,12 @@
 from trytond.transaction import Transaction
 from trytond.pool import Pool
 
+__all__ = ['Work', 'OpenWorkStart', 'OpenWork', 'OpenWork2', 'OpenWorkGraph']
+
 
 class Work(ModelSQL, ModelView):
     'Work'
-    _name = 'timesheet.work'
-    _description = __doc__
-
+    __name__ = 'timesheet.work'
     name = fields.Char('Name', required=True)
     active = fields.Boolean('Active')
     parent = fields.Many2One('timesheet.work', 'Parent', left="left",
@@ -40,48 +40,52 @@
             'readonly': Not(Bool(Eval('active'))),
             })
 
-    def __init__(self):
-        super(Work, self).__init__()
-        self._constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(Work, cls).__setup__()
+        cls._constraints += [
             ('check_recursion', 'recursive_works'),
             ('check_parent_company', 'parent_company'),
-        ]
-        self._error_messages.update({
-            'recursive_works': 'You can not create recursive works!',
-            'parent_company': 'Every work must be in the same company '\
-                'as it\'s parent work!',
-        })
+            ]
+        cls._error_messages.update({
+                'recursive_works': 'You can not create recursive works!',
+                'parent_company': 'Every work must be in the same company '\
+                    'as it\'s parent work!',
+                })
 
-    def default_active(self):
+    @staticmethod
+    def default_active():
         return True
 
-    def default_left(self):
+    @staticmethod
+    def default_left():
         return 0
 
-    def default_right(self):
+    @staticmethod
+    def default_right():
         return 0
 
-    def default_timesheet_available(self):
+    @staticmethod
+    def default_timesheet_available():
         return True
 
-    def default_company(self):
+    @staticmethod
+    def default_company():
         return Transaction().context.get('company')
 
-    def check_parent_company(self, ids):
-        for work in self.browse(ids):
-            if not work.parent:
-                continue
-            if work.parent.company.id != work.company.id:
-                return False
-        return True
+    def check_parent_company(self):
+        if not self.parent:
+            return True
+        return self.parent.company == self.company
 
-    def _tree_qty(self, hours_by_wt, children, ids, to_compute):
+    @classmethod
+    def _tree_qty(cls, hours_by_wt, children, ids, to_compute):
         res = 0
         for h in ids:
             if (not children.get(h)) or (not to_compute[h]):
                 res += hours_by_wt.setdefault(h, 0)
             else:
-                sub_qty = self._tree_qty(
+                sub_qty = cls._tree_qty(
                     hours_by_wt, children, children[h], to_compute)
                 hours_by_wt.setdefault(h, 0)
                 hours_by_wt[h] += sub_qty
@@ -89,10 +93,13 @@
                 to_compute[h] = False
         return res
 
-    def get_hours(self, ids, name):
-        all_ids = self.search([
+    @classmethod
+    def get_hours(cls, works, name):
+        ids = [w.id for w in works]
+        all_works = cls.search([
                 ('parent', 'child_of', ids),
                 ])
+        all_ids = [w.id for w in all_works]
         # force inactive ids to be in all_ids
         all_ids = list(set(all_ids + ids))
         clause = "SELECT work, sum(hours) FROM timesheet_line "\
@@ -113,66 +120,53 @@
         hours_by_wt = dict((i[0], i[1]) for i in
             Transaction().cursor.fetchall())
         to_compute = dict.fromkeys(all_ids, True)
-        works = self.browse(all_ids)
+        works = cls.browse(all_ids)
         children = {}
         for work in works:
             if work.parent:
                 children.setdefault(work.parent.id, []).append(work.id)
-        self._tree_qty(hours_by_wt, children, ids, to_compute)
+        cls._tree_qty(hours_by_wt, children, ids, to_compute)
         return hours_by_wt
 
-    def get_rec_name(self, ids, name):
-        if not ids:
-            return {}
-        res = {}
+    def get_rec_name(self, name):
+        if self.parent:
+            return self.parent.get_rec_name(name) + '\\' + self.name
+        else:
+            return self.name
 
-        def _name(work):
-            if work.parent:
-                return _name(work.parent) + '\\' + work.name
-            else:
-                return work.name
-        for work in self.browse(ids):
-            res[work.id] = _name(work)
-        return res
-
-    def copy(self, ids, default=None):
+    @classmethod
+    def copy(cls, works, default=None):
         if default is None:
             default = {}
         default = default.copy()
         if 'timesheet_lines' not in default:
             default['timesheet_lines'] = None
-        return super(Work, self).copy(ids, default=default)
+        return super(Work, cls).copy(works, default=default)
 
-    def write(self, ids, vals):
-        child_ids = None
+    @classmethod
+    def write(cls, works, vals):
+        childs = None
         if not vals.get('active', True):
-            child_ids = self.search([
-                ('parent', 'child_of', ids),
-                ])
-        res = super(Work, self).write(ids, vals)
-        if child_ids:
-            self.write(child_ids, {
-                'active': False,
-                })
-        return res
-
-Work()
+            childs = cls.search([
+                    ('parent', 'child_of', [w.id for w in works]),
+                    ])
+        super(Work, cls).write(works, vals)
+        if childs:
+            cls.write(childs, {
+                    'active': False,
+                    })
 
 
 class OpenWorkStart(ModelView):
     'Open Work'
-    _name = 'timesheet.work.open.start'
-    _description = __doc__
+    __name__ = 'timesheet.work.open.start'
     from_date = fields.Date('From Date')
     to_date = fields.Date('To Date')
 
-OpenWorkStart()
-
 
 class OpenWork(Wizard):
     'Open Work'
-    _name = 'timesheet.work.open'
-
+    __name__ = 'timesheet.work.open'
     start = StateView('timesheet.work.open.start',
         'timesheet.work_open_start_view_form', [
             Button('Cancel', 'end', 'tryton-cancel'),
@@ -180,39 +174,31 @@
             ])
     open_ = StateAction('timesheet.act_work_hours_board')
 
-    def do_open_(self, session, action):
+    def do_open_(self, action):
         action['pyson_context'] = PYSONEncoder().encode({
-                'from_date': session.start.from_date,
-                'to_date': session.start.to_date,
+                'from_date': self.start.from_date,
+                'to_date': self.start.to_date,
                 })
         return action, {}
 
-    def transition_open_(self, session):
+    def transition_open_(self):
         return 'end'
 
-OpenWork()
-
 
 class OpenWork2(OpenWork):
-    _name = 'timesheet.work.open2'
-
+    __name__ = 'timesheet.work.open2'
     open_ = StateAction('timesheet.act_work_form2')
 
-OpenWork2()
-
 
 class OpenWorkGraph(Wizard):
-    _name = 'timesheet.work.open_graph'
+    __name__ = 'timesheet.work.open_graph'
     start_state = 'open_'
     open_ = StateAction('timesheet.act_work_form3')
 
-    def do_open_(self, session, action):
-        pool = Pool()
-        work_obj = pool.get('timesheet.work')
+    def do_open_(self, action):
+        Work = Pool().get('timesheet.work')
 
         if 'active_id' in Transaction().context:
-            work = work_obj.browse(Transaction().context['active_id'])
+            work = Work(Transaction().context['active_id'])
             action['name'] = action['name'] + ' - ' + work.rec_name
         return action, {}
-
-OpenWorkGraph()
